unit EditTask;

interface

uses Classes, Controls, Forms, StdCtrls, ComCtrls, TaskSyncML, Spin;

type
  TEditTaskForm = class(TForm)
    Label1: TLabel;
    WhatEd: TEdit;
    DueDateDTP: TDateTimePicker;
    DueTimeDTP: TDateTimePicker;
    RemindDateDTP: TDateTimePicker;
    RemindTimeDTP: TDateTimePicker;
    OKBtn: TButton;
    DueCHB: TCheckBox;
    RemindCHB: TCheckBox;
    ComplCHB: TCheckBox;
    lbl1: TLabel;
    PriorED: TSpinEdit;
    DescriptMem: TMemo;
    procedure FormShow(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure DueCHBClick(Sender: TObject);
    procedure RemindCHBClick(Sender: TObject);
  public
    Task: TSMLTask;
  end;

var
  EditTaskForm: TEditTaskForm;

implementation

uses SysUtils;

{$R *.dfm}

procedure TEditTaskForm.FormShow(Sender: TObject);
begin
  WhatEd.Text := Task.Title;
  DescriptMem.Text := Task.Description;
  DueCHB.Checked := (Task.DueTime <> 0);
  DueCHBClick(Sender);
  if DueCHB.Checked then
  begin
    DueDateDTP.DateTime := Trunc(Task.DueTime);
    DueTimeDTP.DateTime := Frac(Task.DueTime);
  end;
  RemindCHB.Checked := (Task.RemindTime <> 0);
  RemindCHBClick(Sender);
  if RemindCHB.Checked then
  begin
    RemindDateDTP.DateTime := Trunc(Task.RemindTime);
    RemindTimeDTP.DateTime := Frac(Task.RemindTime);
  end;
  ComplCHB.Checked := Task.Completed;
  PriorED.Value := Task.Priority;
end;

procedure TEditTaskForm.OKBtnClick(Sender: TObject);
begin
  Task.Title := WhatEd.Text;
  Task.Description := DescriptMem.Text;
  Task.DueTime := Trunc(DueDateDTP.DateTime) + Frac(DueTimeDTP.DateTime);
  Task.RemindTime := Trunc(RemindDateDTP.DateTime) + Frac(RemindTimeDTP.DateTime);
  Task.Completed := ComplCHB.Checked;
  Task.Priority := PriorED.Value;
end;

procedure TEditTaskForm.DueCHBClick(Sender: TObject);
begin
  DueDateDTP.Enabled := DueCHB.Checked;
  DueTimeDTP.Enabled := DueCHB.Checked;
  if not DueCHB.Checked then
  begin
    DueDateDTP.DateTime := 0;
    DueTimeDTP.DateTime := 0;
  end;
end;

procedure TEditTaskForm.RemindCHBClick(Sender: TObject);
begin
  RemindDateDTP.Enabled := RemindCHB.Checked;
  RemindTimeDTP.Enabled := RemindCHB.Checked;
  if not RemindCHB.Checked then
  begin
    RemindDateDTP.DateTime := 0;
    RemindTimeDTP.DateTime := 0;
  end;
end;

end.

